



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Cassandra1.2文档学习（14）—— 事务和并发控制</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Cassandra1.2文档学习（14）—— 事务和并发控制</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 04:56:55 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>参考文档:http://www.datastax.com/documentation/cassandra/1.2/webhelp/index.html#cassandra/dml/dml_about_transactions_c.html#concept_ds_j1p_m5x_zj</p>
<p>　　Cassandra不提供完整的符合ACID特性的事务，ACID事务是关系型数据库系统的标准事务行为：</p>
<p>　　&bull;原子性</p>
<p>　　　　在事务中每一个步要么成功或者回滚整个事务。</p>
<p>　　&bull;一致性</p>
<p>　　　　一个事务不能使数据库处于不一致的状态。</p>
<p>　　&bull;隔离性</p>
<p>　　　　事务不能相互干扰。</p>
<p>　　&bull;持久性</p>
<p>　　　　事务完成以后，更改便持久地保存在数据库之中。</p>
<p>　　作为一个非关系型数据库，Cassandra 不支持连接和外键，因此从ACID的角度来说不提供一致性。例如，让把钱从A账户移到B账户总账目中不改变。 Cassandra支持行一级的原子性和隔离性，但与之交换的是高度的可用性和快速的读写性能。</p>
<p>　　Cassandra写入具有持久性。</p>
<p><strong>一、原子性</strong></p>
<p>　　在Cassandra中，一个写入在行一级是原子性的，插入或更新一个行的各个列认为是一个写入操作。Cassandra不支持多行插入时要么有要么全无这样的事务。同样，但写入在一个副本节点上成功，但是在其他节点失败时，回顾是不会发生的。Cassandra中可以通过一个发送操作的错误报告通知客户端，但事实上一个副本节点上仍然存留着写入的数据。</p>
<p>　　例如，如果使用写的一致性为QUORUM、副本因子为3，Cassandra会复制写入到集群中的各个节点并且等待两个节点的返回。如果写入在其中一个节点失败但是在其他节点成功。Cassandra会报告一个错误去在那个节点上重新执行写入然而，另一个节点写入成功是不会自动回滚的。</p>
<p>　　Cassandra使用时间戳去决定哪一个是最新的更新。时间戳室友客户端程序提供的。当请求数据时最新的时间戳总是会获得胜利，因此如果多个客户端会话同时地更新同一行相同的列，最新的更新是那个最终坚持的。</p>
<p><strong>二、可调的一致性</strong></p>
<p>　　当同时地更新多个行或者多个表时没有锁或者事务依赖。Cassandra支持可以调整的可用性和一致性，并且能提供给你分区耐受性。从<a href="http://www.cs.berkeley.edu/~brewer/cs262b-2004/PODC-keynote.pdf" rel="external nofollow noreferrer">CAP</a> 的来说，Cassandra可以给你很强的一致性当数据连续的分布在在一个分布式数据集群的各个节点上。</p>
<p>　　用户可以选择一个运行准则&mdash;&mdash;多少节点必须接收到DML命令或者对一个SELECT查询做出回应。</p>
<p><strong>三、隔离性</strong></p>
<p>　　在Cassandra 1.1之前，可能会看到部分的更新当一个用户更新行但是另一个用户读取相同行。例如，当一个用户写入一个行，那个行包括2000列，另一个用户可能读取相同行并且见到一些列，但不能看到所有列当写入还在执行的时候。</p>
<p>　　完整的行级别的隔离性现在准备就绪了因此写入到一行是隔离的当客户端执行写入时，并且不可被其他用户访问直到写入成功。</p>
<p>　　从事务ACID的角度看，现在的增强给了Cassandra AID事务的支持。在存储引擎中一个写入是行一级隔离的。</p>
<p><strong>四、持久性</strong></p>
<p>　　Cassandra写入具有持久性。在返回成功之前，副本节点上所有的会被记录在内存中和磁盘上的commit log文件中。如果在内存中的表刷新到磁盘之前，系统崩溃了或者服务器宕机了，commit log文件会在系统重启后重新执行以恢复任何丢失的数据。除了本地的持久性（数据立马被写入到磁盘）将数据复制其他节点上也增强了持久性。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8kpx439.html">CSS3属性transform详解之（旋转&colon;rotate&comma;缩放&colon;scale&comma;倾斜&colon;skew&comma;移动&colon;translate）</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq1n5v59.html">spring 缓存（spring自带Cache）（入门）</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qx1kj09.html">Entity Framework DataAnnotations</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pzr2k8.html">Xamarin Android长度单位区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/r930o409.html">spring整合quartz并持久化</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde01279.html">jQuery&period;validator 详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdewndj9.html">VC让对话框显示就最大化</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdyx4d8.html">js 函数的传值问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wy2nlq.html">Codeforces Round &num;221 &lpar;Div&period; 2&rpar;  Lever  I&period;O&period;U&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xvx468.html">快速预览：C&num; 3&period;0的新东西</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvoxj1q.html">Mysql技术内幕-笔记-第二章 数据类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmypy19.html">Intellij IDEA开发第一个android应用教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7mpzngq.html">NOI2013 Day1</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkdwve8.html">js获取网页的各种高度</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey2lde9.html">mysql数据库在Linux下安装与配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj3ojk9.html">《java入门第一季》之面向对象面试题（成员变量与局部变量的区别）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4rrpm9.html">CentOS上部署&period;net core</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ov33k8.html">Sublime美化配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7oymlx8.html">从零开始一起学习SLAM &vert; 不推公式，如何真正理解对极约束&quest;</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r3wzo9.html">IDEA教程之导入maven项目</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qn1w37j8.html">FatMouse&apos; Trade</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rd7jze8.html">关于try&period;&period;&period;catch&period;&period;&period;finally中return的疑惑</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlmvzw09.html">Swiper Usage&amp;amp&semi;&amp;amp&semi;API</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1316j9.html">jqcss选择器</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvj2g1q.html">js实现堆排序</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1zyvpz9.html">&lbrack;改善Java代码&rsqb;构造函数尽量简化</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnydl2q.html">钓鱼 贪心 end</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnyd4rq.html">li颜色特效</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnydo0q.html">HTTP状态码解读</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j0v26lq.html">R语言diagram包画订单状态流图</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
